<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfContractUpgrade ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfContractUpgrade
 * @subpackage Arrays
 */
class ArrayOfContractUpgrade extends AbstractStructArrayBase
{
    /**
     * The ContractUpgrade
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ContractUpgrade[]
     */
    public $ContractUpgrade;
    /**
     * Constructor method for ArrayOfContractUpgrade
     * @uses ArrayOfContractUpgrade::setContractUpgrade()
     * @param \StructType\ContractUpgrade[] $contractUpgrade
     */
    public function __construct(array $contractUpgrade = array())
    {
        $this
            ->setContractUpgrade($contractUpgrade);
    }
    /**
     * Get ContractUpgrade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ContractUpgrade[]|null
     */
    public function getContractUpgrade()
    {
        return isset($this->ContractUpgrade) ? $this->ContractUpgrade : null;
    }
    /**
     * Set ContractUpgrade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ContractUpgrade[] $contractUpgrade
     * @return \ArrayType\ArrayOfContractUpgrade
     */
    public function setContractUpgrade(array $contractUpgrade = array())
    {
        foreach ($contractUpgrade as $arrayOfContractUpgradeContractUpgradeItem) {
            // validation for constraint: itemType
            if (!$arrayOfContractUpgradeContractUpgradeItem instanceof \StructType\ContractUpgrade) {
                throw new \InvalidArgumentException(sprintf('The ContractUpgrade property can only contain items of \StructType\ContractUpgrade, "%s" given', is_object($arrayOfContractUpgradeContractUpgradeItem) ? get_class($arrayOfContractUpgradeContractUpgradeItem) : gettype($arrayOfContractUpgradeContractUpgradeItem)), __LINE__);
            }
        }
        if (is_null($contractUpgrade) || (is_array($contractUpgrade) && empty($contractUpgrade))) {
            unset($this->ContractUpgrade);
        } else {
            $this->ContractUpgrade = $contractUpgrade;
        }
        return $this;
    }
    /**
     * Add item to ContractUpgrade value
     * @throws \InvalidArgumentException
     * @param \StructType\ContractUpgrade $item
     * @return \ArrayType\ArrayOfContractUpgrade
     */
    public function addToContractUpgrade(\StructType\ContractUpgrade $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ContractUpgrade) {
            throw new \InvalidArgumentException(sprintf('The ContractUpgrade property can only contain items of \StructType\ContractUpgrade, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ContractUpgrade[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ContractUpgrade|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ContractUpgrade|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ContractUpgrade|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ContractUpgrade|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ContractUpgrade|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ContractUpgrade
     */
    public function getAttributeName()
    {
        return 'ContractUpgrade';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfContractUpgrade
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
