<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleContractUpgrade StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:VehicleContractUpgrade
 * @subpackage Structs
 */
class VehicleContractUpgrade extends AbstractStructBase
{
    /**
     * The Colour
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Colour
     */
    public $Colour;
    /**
     * The EngineNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EngineNumber;
    /**
     * The IsHighRisk
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsHighRisk;
    /**
     * The IsTemporary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $IsTemporary;
    /**
     * The Make
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\An_Make
     */
    public $Make;
    /**
     * The Model
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\An_Model
     */
    public $Model;
    /**
     * The Unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUnitType
     */
    public $Unit;
    /**
     * Constructor method for VehicleContractUpgrade
     * @uses VehicleContractUpgrade::setColour()
     * @uses VehicleContractUpgrade::setEngineNumber()
     * @uses VehicleContractUpgrade::setIsHighRisk()
     * @uses VehicleContractUpgrade::setIsTemporary()
     * @uses VehicleContractUpgrade::setMake()
     * @uses VehicleContractUpgrade::setModel()
     * @uses VehicleContractUpgrade::setUnit()
     * @param \StructType\Colour $colour
     * @param string $engineNumber
     * @param bool $isHighRisk
     * @param bool $isTemporary
     * @param \StructType\An_Make $make
     * @param \StructType\An_Model $model
     * @param \ArrayType\ArrayOfUnitType $unit
     */
    public function __construct(\StructType\Colour $colour = null, $engineNumber = null, $isHighRisk = null, $isTemporary = null, \StructType\An_Make $make = null, \StructType\An_Model $model = null, \ArrayType\ArrayOfUnitType $unit = null)
    {
        $this
            ->setColour($colour)
            ->setEngineNumber($engineNumber)
            ->setIsHighRisk($isHighRisk)
            ->setIsTemporary($isTemporary)
            ->setMake($make)
            ->setModel($model)
            ->setUnit($unit);
    }
    /**
     * Get Colour value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Colour|null
     */
    public function getColour()
    {
        return isset($this->Colour) ? $this->Colour : null;
    }
    /**
     * Set Colour value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Colour $colour
     * @return \StructType\VehicleContractUpgrade
     */
    public function setColour(\StructType\Colour $colour = null)
    {
        if (is_null($colour) || (is_array($colour) && empty($colour))) {
            unset($this->Colour);
        } else {
            $this->Colour = $colour;
        }
        return $this;
    }
    /**
     * Get EngineNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEngineNumber()
    {
        return isset($this->EngineNumber) ? $this->EngineNumber : null;
    }
    /**
     * Set EngineNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $engineNumber
     * @return \StructType\VehicleContractUpgrade
     */
    public function setEngineNumber($engineNumber = null)
    {
        // validation for constraint: string
        if (!is_null($engineNumber) && !is_string($engineNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($engineNumber)), __LINE__);
        }
        if (is_null($engineNumber) || (is_array($engineNumber) && empty($engineNumber))) {
            unset($this->EngineNumber);
        } else {
            $this->EngineNumber = $engineNumber;
        }
        return $this;
    }
    /**
     * Get IsHighRisk value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsHighRisk()
    {
        return isset($this->IsHighRisk) ? $this->IsHighRisk : null;
    }
    /**
     * Set IsHighRisk value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isHighRisk
     * @return \StructType\VehicleContractUpgrade
     */
    public function setIsHighRisk($isHighRisk = null)
    {
        if (is_null($isHighRisk) || (is_array($isHighRisk) && empty($isHighRisk))) {
            unset($this->IsHighRisk);
        } else {
            $this->IsHighRisk = $isHighRisk;
        }
        return $this;
    }
    /**
     * Get IsTemporary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getIsTemporary()
    {
        return isset($this->IsTemporary) ? $this->IsTemporary : null;
    }
    /**
     * Set IsTemporary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $isTemporary
     * @return \StructType\VehicleContractUpgrade
     */
    public function setIsTemporary($isTemporary = null)
    {
        if (is_null($isTemporary) || (is_array($isTemporary) && empty($isTemporary))) {
            unset($this->IsTemporary);
        } else {
            $this->IsTemporary = $isTemporary;
        }
        return $this;
    }
    /**
     * Get Make value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\An_Make|null
     */
    public function getMake()
    {
        return isset($this->Make) ? $this->Make : null;
    }
    /**
     * Set Make value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\An_Make $make
     * @return \StructType\VehicleContractUpgrade
     */
    public function setMake(\StructType\An_Make $make = null)
    {
        if (is_null($make) || (is_array($make) && empty($make))) {
            unset($this->Make);
        } else {
            $this->Make = $make;
        }
        return $this;
    }
    /**
     * Get Model value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\An_Model|null
     */
    public function getModel()
    {
        return isset($this->Model) ? $this->Model : null;
    }
    /**
     * Set Model value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\An_Model $model
     * @return \StructType\VehicleContractUpgrade
     */
    public function setModel(\StructType\An_Model $model = null)
    {
        if (is_null($model) || (is_array($model) && empty($model))) {
            unset($this->Model);
        } else {
            $this->Model = $model;
        }
        return $this;
    }
    /**
     * Get Unit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUnitType|null
     */
    public function getUnit()
    {
        return isset($this->Unit) ? $this->Unit : null;
    }
    /**
     * Set Unit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUnitType $unit
     * @return \StructType\VehicleContractUpgrade
     */
    public function setUnit(\ArrayType\ArrayOfUnitType $unit = null)
    {
        if (is_null($unit) || (is_array($unit) && empty($unit))) {
            unset($this->Unit);
        } else {
            $this->Unit = $unit;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleContractUpgrade
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
